#include <stdlib.h>
#include <unistd.h>
#include "getln.h"

struct s_buf		*alloc_getln_buf(int		fd)
{
  struct s_buf		*res;

  if (!(res = malloc(sizeof (struct s_buf))))
    exit(1);
  res->fd = fd;
  res->deb = 0;
  res->all_read = 0;
  res->fin = read(fd, res->tab, BUF_SIZE);
  if (res->fin == -1)
    return NULL;
  if (res->fin < BUF_SIZE && res->fin)
    if (!res->fin || res->tab[res->fin - 1] != '\n')
      {
	res->tab[res->fin] = '\n';
	res->fin++;
      }
  return res;
}

static int		maj_getln_buf(struct s_buf	*buf)
{
  buf->deb = 0;
  if (buf->all_read)
    return 0;
  buf->fin = read(buf->fd, buf->tab, BUF_SIZE);
  if (buf->fin == -1)
    return 0;
  if (!buf->fin)
    buf->all_read = 1;
  if (buf->fin < BUF_SIZE)
    if (!buf->fin || buf->tab[buf->fin - 1] != '\n')
      {
	buf->tab[buf->fin] = '\n';
	buf->fin++;
      }
  return 1;
}

static void		calc_dfl(struct s_buf		*buf,
				 int			*deb,
				 int			*fin,
				 int			*len)
{
  int			i;

  *deb = buf->deb;
  *fin = buf->fin;
  for (i = *deb; i < *fin; i++)
    if (buf->tab[i] == '\n')
      break;
  *len = i - *deb;
}

static int		build_str(struct s_buf		*buf,
				  char			**res,
				  int			old_len)
{
  int			i;
  int			deb;
  int			fin;
  int			len;

  calc_dfl(buf, &deb, &fin, &len);
  if (!(*res = realloc(*res, (old_len + len + 1) * sizeof (char))))
    exit(1);
  for (i = 0; i < len; i++)
    (*res)[old_len + i] = buf->tab[deb + i];
  if (deb + len != fin)
    {
      (*res)[old_len + len] = '\0';
      buf->deb = deb + len + 1;
      return old_len + len;
    }
  if (!maj_getln_buf(buf) ||
      (buf->all_read && old_len + len == 0))
    {
      free(*res);
      return -1;
    }
  return build_str(buf, res, old_len + len);
}

char			*getln(struct s_buf		*buf)
{
  char			*res = NULL;

  if (buf->all_read || build_str(buf, &res, 0) == -1)
    return NULL;
  else
    return res;
}
